#!/usr/bin/perl
use strict;
use warnings;
use File::Glob ':glob';

my @sets = ();
my @alias = ();

open(my $ind, "<", "setdata.txt") or die "Can't open file: $!";
while(<$ind>){
	my $line = $_;
	if($line eq "\n") {next;}
	chomp($line);
	my @values = split(/\|/, $line);
	my $var = substr($values[2], -3);
	push(@sets, $var);
	if((my $alt = scalar(@values)) == 5) {
		my $varb = substr($values[4],-3); 
		if($varb ne "EVT"){
		push(@sets, $varb); 
		push(@alias, $varb); push(@alias, $var);}}
}
close $ind or die $!;

my $numsets = scalar(@sets);
print "$numsets set codes read in.\n";

my $userinput = "";

my @filelist = glob("*.dck");
my $numfiles = scalar(@filelist);
print "$numfiles deck files found.\n";

for(my $deck = 0; $deck < $numfiles; $deck++) {
my $file = $filelist[$deck];
if($userinput ne "A"){
	print "Convert $file?\n (Yes/All\!/List deckfile/Quit/any other key to skip file)"; 
	$userinput = <stdin>;
	chomp ($userinput);
	$userinput = uc($userinput);
	}

if(($userinput eq "Y") or ($userinput eq "A")){
open(my $in, "<", $file) or die "Can't open file: $!";

my @data=<$in>;
close $in or die $!;
chomp(@data);

my $deckfilelen = scalar (@data);
#print "$deckfilelen";
	
my $count = 0;
my $countb = 0;
my $x = 0;
my $y = 1000;

#determine the array indexes between [main] and [sideboard]
while($count < $deckfilelen){	
	#print "$count - $data[$count]";
	if($data[$count] eq "[main]") {$x=$count+1;}
	if($data[$count] eq "[sideboard]") {$y=$count;}
	$count++;
	}

#strip set assignment from cards @data if there is one
for($count = $x; $count < $y; $count++){
	my @values = split(/\|/, $data[$count]);
	foreach my $val (@values) {$data[$count]=$values[0]}
	#print "$data[$count]\n";
	}

my $z = 0;
my $numcards = $y - $x;
my @cards = (1..$numcards);
my @cardnum = @cards;

#put card names only into array @cards
for($count = $x; $count < $y; $count++){
	my @values = split(' ', $data[$count]);
	$cardnum[$z]= $values[0];
	if($values[0] > 99) { die "Unexpected number of a card!";}
	if($values[0] < 1) { die "Unexpected number of a card!";}
	if($values[0] < 10) {
		$cards[$z] = substr $data[$count], 2;
		} else {
		$cards[$z] = substr $data[$count], 3;
		}
	#print "$cards[$z]\n";
	$z++;
	}
#for (my $q = 0 ; $q < scalar(@cards); $q++){ print "$cardnum[$q] $cards[$q]\n";} die;

#bugfix: trim spaces from end of cardnames
foreach my $trim (@cards) {$trim =~ s/\s+$//;}
foreach my $trim (@data) {$trim =~ s/\s+$//;}
#for (my $q = 0 ; $q < scalar(@cards); $q++){ print "$cards[$q]-\n";} die;

my $tempnum = 0;
my $space = " ";

#finds multiples of a card and combines them into a single line item
for($count = 0; $count < $numcards; $count++){
	for($z = $count+1; $z < $numcards; $z++){
		if($cards[$count] eq $cards[$z]){ 
			$tempnum = $cardnum[$count] + $cardnum[$z]; 
			$numcards--;
			$y--;
			$data[$count+$x] = $tempnum.$space.$cards[$count];
			$cardnum[$count] += $cardnum[$z];
			splice(@data, $z + $x, 1);
			splice(@cards, $z, 1);
			splice(@cardnum, $z, 1);
			$z--;
		}
	}
}

my @setscards = @cards;
my $start = 0;
$count = 0;
my $compcount = 0;
my $matchcount = 0;
my $match = -1;
my $name = ();
my $cardsfound = 0;
my $addedsets = 0;

open(my $inb, "<", "mtg-data.txt") or die "Can't open file: $!";

while(<$inb>){
	my $line = $_;
	if($line eq "\n") {$start = 1;}

	#finds line with set codes and inserts codes into @setscards after the cardname
	if($match > -1) {
		my $findsets = $line; 
		chomp($findsets);
		my @searchline = split(' ', $findsets);
		foreach my $search (@searchline){
			for($matchcount = 0; $matchcount < $numsets; $matchcount++){
				if($search eq $sets[$matchcount]) {
					$match++;
					splice(@setscards, $match, 0, $sets[$matchcount]);
					#print "$setscards[$match-1] - $sets[$matchcount]\n";<stdin>;
					$addedsets=1;	
					}
				}
			}
		if($addedsets == 1) {$addedsets = 0; $match = -1;};
		}

	#finds matches in mtg-data to @cards and sets $match to the index of @setscards where matched card is
	if($start == 1) {
		$name = $line;
		chomp($name); 
		for($compcount = 0; $compcount < $numcards; $compcount++){
			if($cards[$compcount] eq $name) {
				#print "Found $name\n";
				$cardsfound++;
				for(my $ind = $compcount; $ind < scalar(@setscards); $ind++)
				{if($setscards[$ind] eq $name) {$match = $ind; last;}}
				$start = 0;
				#for (my $q = 0 ; $q < scalar(@setscards); $q++){ print "$setscards[$q]\n";} <stdin>;
				last;
				}
			else { $start = 0;}
		}
	}
	if(($line eq "\n")&&($start==0)) {$start = 1;}
	if(($cardsfound == $numcards)&&($match == -1)) {last;}
}

close $inb or die $!;
#line 118
if($cardsfound != $numcards) {print "Could not find all cards in $file"; <stdin>; next;}
#for (my $q = 0 ; $q < scalar(@setscards); $q++){ print "$setscards[$q]\n";} die;
#for (my $q = 0 ; $q < scalar(@sets); $q++){ print "$sets[$q],$dates[$q]\n";} die;

my @assigned = @cards;
my $nextcard = 0;
my $a = 0;
my $currentcard = 0;
my $assignedcards = 0;

for($count = 0; $count < $numsets; $count++){
	#print "Testing $sets[$count]\n"; 
	my $notpreffered = 0;
	if(($sets[$count] eq "POR") or ($sets[$count] eq "PO2") or ($sets[$count] eq "P02") or ($sets[$count] eq "S99") or ($sets[$count] eq "S00")) {$notpreffered = 1;}
	$nextcard = 0;
	for($a = 0; $a < scalar(@setscards); $a++){
		if($nextcard != $numcards){
		if($setscards[$a] eq $cards[$nextcard]) {
			#print "$cards[$nextcard]\n"; 
			$currentcard = $nextcard; 
			$nextcard++; $a++;
			}}
		#print "$sets[$count] = $setscards[$a]?\n";
		if($sets[$count] eq $setscards[$a]) {
			if(($notpreffered == 0) or ($assigned[$currentcard] eq $cards[$currentcard])) {
			      	$assigned[$currentcard] = $setscards[$a];
				#print "$cards[$currentcard] assigned $setscards[$a]\n";
				}
			}
	        }
	$assignedcards = 0;
	for(my $n = 0; $n < $numcards; $n++){
		if($cards[$n] ne $assigned[$n]) {$assignedcards++}}
	#print "Assigned $assignedcards of $numcards\n"; <stdin>; 
	if($assignedcards == $numcards) { last;}
	}


#for (my $q = 0 ; $q < scalar(@cards); $q++){ print "$cards[$q],$assigned[$q]\n";} 
$a = 0;

for($count = 0; $count < scalar(@assigned); $count++){
	for(my $q = 0; $q < scalar(@alias); $q=$q+2){
		if($alias[$q] eq $assigned[$count]){$assigned[$count] = $alias[$q+1];}
	}
}

for($count = $x; $count < $y; $count++){
	my $temp = "|$assigned[$a]";
	$data[$count] = $data[$count].$temp;
	$a++;
}
for($count = 0; $count < scalar(@data); $count++){
	my $temp = "\n";
	$data[$count] = $data[$count].$temp;
}

#print "@data"; 

my $dir = 'output/';

unless(-d $dir){ mkdir $dir or die;}

open(my $out, ">", $dir.$file) or die "Can't open file: $!";
print $out @data;
close $out or die $!;
if($userinput ne "A"){print "Success!\n";} else {print "$file converted!\n";} 
}
if($userinput eq "Q") {exit;}
if($userinput eq "L"){
	open(my $ine, "<", $file) or die "Can't open file: $!";
	my @datab=<$ine>;
	close $ine or die $!;
	print "\n@datab\n";
	$deck--;}	
}